<?php
namespace inshok\admin\controllers\admin;

use \inshok\admin\controllers\interfaces\InterfaceProcess;
use \inshok\admin\helpers\Html;
use \inshok\admin\helpers\Message;


use inshok\admin\database\PdoLogin;



class AdminController implements InterfaceProcess 
{

    use Html;

    public function process(): void
    {


        if( $_POST ) {

            $email = filter_input(INPUT_POST , 'usercontact_email' ,  FILTER_SANITIZE_STRING);
            $pass = filter_input(INPUT_POST , 'userlogin_pass' ,  FILTER_SANITIZE_STRING);

            $podlogin = new PdoLogin();
            $podlogin_data = $podlogin->verify( $email );


            if( $podlogin_data ) {

                $verify_login = $this->verifyLogin( $podlogin_data , $pass );

                if( $verify_login ) {

                    Header('Location: ./dashboard', false, 302);

                }

            } else {

                Message::set( 'E-mail ou senha inválido(s)' );

            }
                
            
        }

        $args = [
            'pathJS' => 'admin.js',
            'message_return' => Message::get()
        ];

        $path = 'admin/admin.php';

        echo $this->render($path , $args);
        
        
        Message::destroy();

    }


    private function verifyLogin( $data , $pass ) {

        if( $this->validate( $data['userlogin_pass'] , $pass ) ) {

            $_SESSION['login'] = [
                'id' => $data['user_id'],
                'active' => $data['userlogin_active'],
                'access' => $data['userlogin_access'],
            ];
            
            return true;

        } else {

            Message::set( 'E-mail ou senha inválido(s)' );
            return false;

        }

    }

    //
    public function validate($passHash, $passPure)
    {
        return password_verify($passPure, $passHash);
    }


    public static function login() {

        if( empty($_SESSION['login'] ) || !isset( $_SESSION['login'] ) ) {
            return false;
        }
        
        return $_SESSION['login'];

    }
 
}
