<?php
namespace inshok\admin\controllers\admin;

use \inshok\admin\controllers\interfaces\InterfaceProcess;
use \inshok\admin\helpers\Html;
use \inshok\admin\helpers\Message;

use \inshok\admin\database\PdoClinic;


class ListClinicsController implements InterfaceProcess {

    
    use Html;


    public function process(): void
    {

        
        $action = filter_input( INPUT_GET , 'action' , FILTER_SANITIZE_STRING );
        $id = filter_input( INPUT_GET , 'id' , FILTER_SANITIZE_STRING );
        

        $login = AdminController::login();
        $login_id = $login['id'];


        $pdo_clinic = new PdoClinic();
        if( $action == 'delete' )  {

            $pdo_clinic_delete = $pdo_clinic->delete( $id , $login_id );

        }


        $args = [
            'access' => $login['access'],
        ];

        
        if(Message::get()) {
            $args['message_return'] = Message::get();
            Message::destroy();
        }

        $pdo_clinic_list = $pdo_clinic->fulllist( $login_id );
        if( !empty( $pdo_clinic_list ) ) {
            $args['clinic_list'] = $pdo_clinic_list;
        }


        $path = 'admin/list-clinics.php';
        echo $this->render($path , $args);
    
        

    }


}




