<?php
namespace inshok\admin\controllers\admin;

use \inshok\admin\controllers\interfaces\InterfaceProcess;
use \inshok\admin\helpers\Html;

use \inshok\admin\database\PdoUser;


class ListUserController implements InterfaceProcess {

    
    use Html;


    public function process(): void
    {

        $action = filter_input( INPUT_GET , 'action' , FILTER_SANITIZE_STRING );
        $id = filter_input( INPUT_GET , 'id' , FILTER_SANITIZE_STRING );

        
        $login = AdminController::login();
        $login_id = $login['id'];

        $message_return_text = '';
        $message_return = 0;


        $pdo_user = new PdoUser();
        if( $action == 'delete' )  {

            $message_return = $pdo_user->delete( $id );
            if($message_return == 2) {

                $message_return_text = 'Você não pode excluir o usuário master.';
                
            } else {
                
                $message_return_text = 'Usuário excluído com sucesso.';
            }

        }

        
        $args = [
            'pathJS' => 'list-users.js',
            'access' => $login['access'],
            'message_return' => $message_return,
            'message_return_text' => $message_return_text,
            'login_id' => $login_id
        ];
        

        $pdo_user_list = $pdo_user->fulllist();


        if( !empty( $pdo_user_list ) ) {
            $args['user_list'] = $pdo_user_list;
        }


        $path = 'admin/list-users.php';
        echo $this->render($path , $args);
    

    }

}




