<?php

namespace inshok\admin\controllers\admin;

use \inshok\admin\controllers\interfaces\InterfaceProcess;
use \inshok\admin\helpers\Html;
use \inshok\admin\helpers\Message;
use \inshok\admin\database\PdoClinic;


class RegisterLinksController implements InterfaceProcess {

    
    use Html;


    public function process(): void
    {
        $action = filter_input(INPUT_GET , 'action' , FILTER_SANITIZE_STRING);
        $id = filter_input(INPUT_GET , 'id' , FILTER_SANITIZE_STRING);

        $login = AdminController::login();
        $login_id = $login['id'];


        $pdo_clinic = new PdoClinic();
        
        if( empty($action) ) $action = 'insert';
        $clinic_id = 0;
        $page_title = 'Links de apoio';

        if( $action == 'update' ) {

            $pdo_clinic_list = $pdo_clinic->list( $id , $login_id );
            $clinic_id = $id;
            $page_title = 'Alterar Links de localização';

        }


        if( $_POST ) {

            $post_vars = [
                'user_id' => $login_id,
                'clinic_id' => $clinic_id,
                'clinicadress_waze' => filter_input(INPUT_POST , 'clinicadress_waze' , FILTER_SANITIZE_STRING),
                'clinicadress_googlemaps' => filter_input(INPUT_POST , 'clinicadress_googlemaps' , FILTER_SANITIZE_STRING),
            ];
            

            $pdo_clinic_save = $pdo_clinic->saveLinks( $post_vars );

            if( $pdo_clinic_save ) {

                Message::set( 'Links de localização alterados com sucesso' );
                Header ('Location: /lista-unidades');
                exit();


            }


        }

        $text_button = 'Inserir Clínica';
        if( isset( $pdo_clinic_list )) {
            $text_button = 'Alterar Clínica';
        }


        // Página da lista de usuários
        // 
    
        $args = [
            'pathJS' => 'register-links.js',
            'access' => $login['access'],
            'message_return_text' => Message::get(),
            'text_button' => $text_button,
            'action' => $action,
            'page_title' => $page_title
        ];

        if( isset( $message_return ) ) {
            $args['message_return'] = $message_return;
        }

        if( isset( $pdo_clinic_list )) {
            $args['clinic_list'] = $pdo_clinic_list;
        }

        

        $path = 'admin/register-links.php';
        echo $this->render($path , $args);


        Message::destroy();
    

    }


}
