<?php
namespace inshok\admin\controllers\admin;

use \inshok\admin\controllers\interfaces\InterfaceProcess;



// Mailtrap para utilizar um servidor de envio de e-mails

//require __DIR__ . '/../../vendor/autoload.php';
//require __DIR__ . '/../../vendor/phpmailer/phpmailer/src/Exception.php';
//require __DIR__ . '/../../vendor/phpmailer/phpmailer/src/PHPMailer.php';
//require __DIR__ . '/../../vendor/phpmailer/phpmailer/src/SMTP.php';

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;
use PHPMailer\PHPMailer\SMTP;


class SendMailController implements InterfaceProcess 
{

    private $mail;

    private $settings = [];
    private $recipients = [];
    private $attachments = [];

    public function __construct()
    {
        $this->mail = new PHPMailer();
    }


    public function process(): void
    {


        if( count($this->settings) > 0 && count($this->recipients) > 0 ) {
            try {
                

                $success = $this->mail->send();
                //"Email enviado com sucesso";

            } catch (Exception $e) {
    
                //"Message could not be sent. Mailer Error: {$this->mail->ErrorInfo}";
            
            }
        }
        

    }

    public function subject( $subject ) {

        $this->mail->Subject = $subject;
       
    }



    public function settings( $settings ) {

        $this->settings = $settings;

        //Server settings
        //$this->mail->SMTPDebug = SMTP::DEBUG_SERVER;
        $this->mail->isSMTP();
        $this->mail->Host =  $this->settings['Host'];
        $this->mail->SMTPAuth = true; //Verificar no servidor
        $this->mail->Port =  $this->settings['Port'];             
        $this->mail->Username = $this->settings['Username'];
        $this->mail->Password = $this->settings['Password'];
        $this->mail->SMTPSecure = false;
        $this->mail->SMTPAutoTLS = false;
    }


    public function recipients( $recipients ) {


        /*
        $recipients = [
            'from' => ['from@example.com','Mailer'],
            'address' => ['joe@example.net','Joe User'],
            'replyto' => ['info@example.com','Information'],
            'cc' => ['cc@example.com'],
            'bcc' => ['bcc@example.com']
        ];
        */

        $this->recipients = $recipients;


        //Recipients
        $this->mail->setFrom($this->recipients['from'][0], $this->recipients['from'][1]);
        $this->mail->addAddress($this->recipients['address'][0], $this->recipients['address'][1]);
        $this->mail->addReplyTo($this->recipients['replyto'][0],$this->recipients['replyto'][1] );
        //$this->mail->addCC($recipients['cc']);
        //$this->mail->addBCC($recipients['bcc']);
        
    }

    public function attachments( $attachments ) {

        /*
        $attachments = [
            'attachment' => '/var/tmp/file.tar.gz'
        ];
        */

        $this->attachments = $attachments;

        //Attachments
        $this->mail->addAttachment($this->attachments['attachment'][0]);

        
    }
    
    public function html( $html ) {
        $this->mail->isHTML(true);
        $this->mail->CharSet = 'utf-8';
        $this->mail->Body = $html;
    }
 
}
