<?php

namespace inshok\admin\controllers\admin;

use \inshok\admin\controllers\interfaces\InterfaceProcess;
use \inshok\admin\helpers\Html;
use \inshok\admin\helpers\Message;
use \inshok\admin\database\PdoMessage;


class UpdateMessageController implements InterfaceProcess {

    
    use Html;
    
    
    public function process(): void
    {
        
        $action = filter_input(INPUT_GET , 'action' , FILTER_SANITIZE_STRING);
        $id = filter_input(INPUT_GET , 'id' , FILTER_SANITIZE_STRING);

        $login = AdminController::login();
        $login_id = $login['id'];


        $pdo_message = new PdoMessage();
        
        if( empty($action) ) $action = 'none';
        $clinic_id = 0;
        $page_title = 'Mensagem';

        if( $action == 'update' ) {

            $pdo_message_list = $pdo_message->list( $id , $login_id );
            $action = 'update';
            $clinic_id = $id;
            $page_title = 'Alterar Mensagem';

        } else {

            Header ('Location: /lista-unidades');
            exit();

        }


        if( $_POST ) {

            $post_vars = [
                'user_id' => $login_id,
                'clinic_id' => $clinic_id,
                'messages_text' => filter_input(INPUT_POST , 'messages_text' , FILTER_SANITIZE_STRING),
            ];
            

            $pdo_message_save = $pdo_message->save( $post_vars );

            if( $pdo_message_save ) {

                Message::set( 'Mensagem alterada com sucesso' );
                Header ('Location: /lista-unidades');
                exit();


            }


        }

        $text_button = 'Alterar mensagem';
       

        $args = [
            'pathJS' => 'update-message.js',
            'access' => $login['access'],
            'text_button' => $text_button,
            'action' => $action,
            'page_title' => $page_title
        ];

        if( isset( $message_return ) ) {
            $args['message_return'] = $message_return;
        }


        if( isset( $pdo_message_list )) {
            $args['message_list'] = $pdo_message_list;
        }
       

        $path = 'admin/update-message.php';
        echo $this->render($path , $args);


        Message::destroy();
    

    }


}

