<?php 
namespace inshok\admin\database;

use inshok\admin\database\ConnectionCreator;


use PDO;

class PdoDoctor 
{

    public function __construct()
    {
        
        $this->connection = ConnectionCreator::createConnection();

    }

    
    public function fulllist( $user_id , $doctor_id ) 
    {

        $sqlInstruction = 'CALL P_ListDoctor( :user_id, :doctor_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', $user_id , PDO::PARAM_INT);
        $statement->bindValue(':doctor_id', $doctor_id , PDO::PARAM_INT);
        $statement->execute();

        $data_array = [];
        while($data = $statement->fetch(PDO::FETCH_ASSOC)) {
            $data_array[] = [
                'doctor_id' => $data["doctor_id"],
                'doctor_name' => $data["doctor_name"],
                'doctor_description' => $data["doctor_description"],
                'doctor_specialty' => $data["doctor_specialty"],
            ];
        }

        return $data_array;
    }


    

    public function save( $post_vars )
    {

       
        $sqlInstruction = 'CALL P_UpdateDoctor( :user_id, :doctor_id, :doctor_name, :doctor_description, :doctor_specialty )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', $post_vars['user_id'] , PDO::PARAM_INT);
        $statement->bindValue(':doctor_id', $post_vars['doctor_id'] , PDO::PARAM_STR);
        $statement->bindValue(':doctor_name', $post_vars['doctor_name'] , PDO::PARAM_STR);
        $statement->bindValue(':doctor_description', $post_vars['doctor_description'] , PDO::PARAM_STR);
        $statement->bindValue(':doctor_specialty', $post_vars['doctor_specialty'] , PDO::PARAM_STR);
        $statement->execute();
        
        $data = $statement->fetch(PDO::FETCH_ASSOC);

        return $data;
        
    }



    public function delete( $user_id , $doctor_id )
    {

        $sqlInstruction = 'CALL P_DeleteDoctor( :user_id , :doctor_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', $user_id , PDO::PARAM_INT);
        $statement->bindValue(':doctor_id', $doctor_id , PDO::PARAM_INT);
        
        return $statement->execute();;
    }


    

}


