<?php 
namespace inshok\admin\database;

use inshok\admin\database\ConnectionCreator;


use PDO;

class PdoScheduling 
{

    public function __construct()
    {
        
        $this->connection = ConnectionCreator::createConnection();

    }

    public function list( $key ) 
    {


        $sqlInstruction = 'CALL P_SchedulingListByKey( :schedulingKey )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':schedulingKey', $key , PDO::PARAM_STR);
        $statement->execute();
        
        $data = $statement->fetch(PDO::FETCH_ASSOC);

        return $data;
    }


    public function fulllist( $scheduling_id , $clinic_id , $scheduling_date ) 
    {


        $sqlInstruction = 'CALL P_SchedulingList( :scheduling_id, :clinic_id, :scheduling_date )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':scheduling_id', $scheduling_id , PDO::PARAM_INT);
        $statement->bindValue(':clinic_id', $clinic_id , PDO::PARAM_INT);
        $statement->bindValue(':scheduling_date', $scheduling_date , PDO::PARAM_STR);
        $statement->execute();
        
        $data_array = [];
        while($data = $statement->fetch(PDO::FETCH_ASSOC)) {
            
            $data_array[] = [
                'scheduling_id' => $data["scheduling_id"],
                'scheduling_description' => $data["scheduling_description"],
                'scheduling_dateconsultation' => $data["scheduling_dateconsultation"],
                'scheduling_checkout' => $data["scheduling_checkout"],
                'scheduling_status' => $data["scheduling_status"],
                'patient_name' => $data["patient_name"],
                'patient_email' => $data["patient_email"],
                'patient_whatsapp' => $data["patient_whatsapp"],
                'clinic_id' => $data["clinic_id"],
                'doctor_id' => $data["doctor_id"],
                'doctor_name' => $data["doctor_name"],
                'scheduling_key' => $data["scheduling_key"],
            ];
            
        }

        return $data_array;
    }


    
    public function save( $post_vars )
    {


        $sqlInstruction = 'CALL P_SchedulingUpdate( :scheduling_id, :user_id, :patient_name, :patient_email, :patient_whatsapp, :scheduling_description, :scheduling_dateconsultation, :scheduling_key, :doctor_id, :clinic_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':scheduling_id', $post_vars['scheduling_id'] , PDO::PARAM_STR);
        $statement->bindValue(':user_id', $post_vars['user_id'] , PDO::PARAM_INT);
        $statement->bindValue(':patient_name', $post_vars['patient_name'] , PDO::PARAM_STR);
        $statement->bindValue(':patient_email', $post_vars['patient_email'] , PDO::PARAM_STR);
        $statement->bindValue(':patient_whatsapp', $post_vars['patient_whatsapp'] , PDO::PARAM_STR);
        $statement->bindValue(':scheduling_description', $post_vars['scheduling_description'] , PDO::PARAM_STR);
        $statement->bindValue(':scheduling_dateconsultation', $post_vars['scheduling_dateconsultation'] , PDO::PARAM_STR);
        $statement->bindValue(':scheduling_key', $post_vars['scheduling_key'] , PDO::PARAM_STR);
        $statement->bindValue(':doctor_id', $post_vars['doctor_id'] , PDO::PARAM_INT);
        $statement->bindValue(':clinic_id', $post_vars['clinic_id'] , PDO::PARAM_INT);
        $statement->execute();
        
        // 
        
        $data = $statement->fetch(PDO::FETCH_ASSOC);

        return $data;
        
    }

    public function delete( $scheduling_id )
    {

        $sqlInstruction = 'CALL P_SchedulingDelete( :scheduling_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':scheduling_id', $scheduling_id , PDO::PARAM_INT);
               
        
        return $statement->execute();;
    }

    
    public function checkout( $scheduling_id )
    {

        $sqlInstruction = 'CALL P_SchedulingCheckout( :scheduling_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':scheduling_id', $scheduling_id , PDO::PARAM_INT);
        
        return $statement->execute();
    }

    

    

}


