<?php 
namespace inshok\admin\database;

use inshok\admin\database\ConnectionCreator;


use PDO;

class PdoUser 
{

    public function __construct()
    {
        
        $this->connection = ConnectionCreator::createConnection();

    }

    public function list( $id ) 
    {


        $sqlInstruction = 'CALL P_UserList( :user_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', $id , PDO::PARAM_STR);
        $statement->execute();
        
        $data = $statement->fetch(PDO::FETCH_ASSOC);

        return $data;
    }


    public function fulllist() 
    {


        $sqlInstruction = 'CALL P_UserList( :user_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', 0 , PDO::PARAM_INT);
        $statement->execute();

        $data_array = [];
        while($data = $statement->fetch(PDO::FETCH_ASSOC)) {
            $data_array[] = [
                'id' => $data["user_id"],
                'name' => $data["user_name"],
                'cpf' => $data["user_cpf"],
                'email' => $data["usercontact_email"],
                'whatsapp' => $data["usercontact_cel1"],
                'access' => $data["userlogin_access"]
            ];
        }

        return $data_array;
    }


    

    public function save( $post_vars )
    {

        $sqlInstruction = 'CALL P_UserUpdate( :user_id, :user_access, :user_name, :user_cpf, :usercontact_email, :usercontact_cel1, :userlogin_pass )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', $post_vars['user_id'] , PDO::PARAM_INT);
        $statement->bindValue(':user_access', $post_vars['user_access'] , PDO::PARAM_INT);
        $statement->bindValue(':user_name', $post_vars['user_name'] , PDO::PARAM_STR);
        $statement->bindValue(':user_cpf', $post_vars['user_cpf'] , PDO::PARAM_STR);
        $statement->bindValue(':usercontact_email', $post_vars['usercontact_email'] , PDO::PARAM_STR);
        $statement->bindValue(':usercontact_cel1', $post_vars['usercontact_cel1'] , PDO::PARAM_STR);
        $statement->bindValue(':userlogin_pass', $post_vars['userlogin_pass'] , PDO::PARAM_STR);
        $statement->execute();

        
        $data = $statement->fetch(PDO::FETCH_ASSOC);

        return $data;
        
    }
    


    public function delete( $id )
    {

        $sqlInstruction = 'CALL P_UserDelete( :user_id )';
        $statement = $this->connection->prepare($sqlInstruction);
        $statement->bindValue(':user_id', $id , PDO::PARAM_INT);
        $statement->execute();

        $data = $statement->fetch(PDO::FETCH_ASSOC);

        return $data['message_return'];
    }


    

}


