
export class ConfigForm
{

    _event = 'click';

    constructor( target )
    {
        this.target = target;
    }

    configInputs( query , event , error ) {
        this._event = event;

        this.inputs = document.querySelectorAll( query );
        this.inputs.forEach(input => {
            input.addEventListener( this._event , (event) => {
                
                const validate = this.target.validate(event.target);
                
                let targetError = event.target.parentElement.querySelector(`[data-${error}]`);
                if(validate !== true) {
                    targetError.textContent = validate;
                    targetError.classList.add('error-active');
                } else {
                    targetError.textContent = '';
                    targetError.classList.remove('error-active');
                }
            });
        });
    }

    configSend( dataVar ) {
        const formSend = document.querySelector(dataVar);
        formSend.addEventListener('submit', ( event ) => {
            event.preventDefault();
            
            const validInput = this._verifyValidateForm();
            if(validInput === true) {
                event.target.submit();
            }
        })
    }

    _verifyValidateForm() {
        const valids = [];
        const blurEvent = new Event( this._event );
        this.inputs.forEach(input => {
            if(!input.validity.valid) {
                input.dispatchEvent(blurEvent);
            }

            valids.push(input.validity.valid);
        });

        const retorno = valids.every(valid => {
            if(!valid) {
                return false;
            }
            return true;
        });

        return retorno;
    }
}















/*
const inputUser = document.querySelector('[data-type="user"]');
const inputPass = document.querySelector('[data-type="pass"]');

const validateUser = login.validate( inputUser );
if(validateUser  !== true) {
    console.log(validateUser);
}

const validatePass = login.validate( inputPass );
if(validatePass  !== true) {
    console.log(validatePass);
}
*/



