export class SchedulingView
{
    
    constructor()
    {

    }

    render( json )
    {
        this.json = json;
        
        const container = document.createElement('div');
        container.classList.add('container');
        container.innerHTML += this._renderPacient();
        container.innerHTML += this._renderInformation();
        container.innerHTML += this._rendePosition();
        container.innerHTML += this._renderEstimatedTime();

        return container;

    }

    _renderPacient()
    {

        return `
            <p class="card-text" data-scheduling="information">
                Olá, <span class="font-weight-bold">${ this.json.patientName }</span>
            </p>
        `
    }
    
    _renderInformation()
    {

        //const date_consultation = new Date( this.json.schedulingDateconsultation );
        //console.log(date_consultation);

        return `
            <p class="card-text" data-scheduling="information">
                Sua consulta está agendada na clínica <span class="font-weight-bold">${ this.json.clinicName } às ${ this.json.schedulingDateconsultation }hrs, com a ${ this.json.doctorName }</span>
            </p>
        `
    }


    _rendePosition()
    {
        return `
            <h3 class="card-title text-center">Sua posição na fila de espera é:</h3>
            <p class="card-highlighted text-center">${ this.json.position }º</p>
        `

        // Implementar janela pra quando o paciênte tiver atrasado
    }

    
    _renderEstimatedTime()
    {

        const _position = Number(this.json.position);
        
        let _average_time = new Date(this.json.averageTime);
        
        
        let _hours = _average_time.getHours() * _position;
        let _hours_rest = 0;
        if( _hours % _position ) {
            _hours_rest = _hours % _position;
        }
        
        let _minutes = _average_time.getMinutes() * _position;
        let _minutes_rest = 0;
        if( _hours_rest ) _minutes += _hours_rest;
        if( _minutes % _position ) {
            _minutes_rest = _minutes % _position;
        }
        
        let _seconds = _average_time.getSeconds() * _position;
        if( _minutes_rest ) {
            _seconds += _minutes_rest;
        }



        let _formated_hours = '';
        if( _hours <= 0 ) {
            _formated_hours = '0' + String(_hours);
        } else {
            _formated_hours = _hours;  
        }
        
        let _formated_minutes = '';
        if( _minutes <= 0 ) {
            _formated_minutes = '0' + String(_minutes);
        } else {
            _formated_minutes = _minutes;  
        }

        let _formated_seconds = '';
        if( _seconds <= 0 ) {
            _formated_seconds = '0' + String(_seconds);
        } else {
            _formated_seconds = _seconds;  
        }



        //const _str_date = `${ _formated_hours }:${ _formated_minutes }:${ _formated_seconds }`;
        const _str_date = `O tempo estimado precisa ser:  ((hora_da_consulta - hora_atual) / media_de_tempo_dos_atendimentos_realizados) * quantidade_de_agendamentos `;
        

        return `
            <p class="card-text">O tempo de espera estimado é de aproximadamente <span class="font-weight-bold" data-scheduling="estimated-time">${ _str_date }</span></p>
        `
    }

    _timer() {
        
        // Montar contagem regressiva

    }
}
